package org.openjdk.gcbench.alloc.special;

import org.openjdk.jmh.annotations.*;
import org.openjdk.jmh.infra.Blackhole;

import java.lang.ref.PhantomReference;
import java.lang.ref.ReferenceQueue;
import java.lang.ref.SoftReference;
import java.util.concurrent.TimeUnit;

@BenchmarkMode(Mode.AverageTime)
@OutputTimeUnit(TimeUnit.NANOSECONDS)
@State(Scope.Benchmark)
public class SoftRefs {

    ReferenceQueue<Object> rq;

    @Setup
    public void setup() {
        rq = new ReferenceQueue<>();
    }

    public void drain() {
        while (rq.poll() != null); // drain
    }

    @Benchmark
    public void test(Blackhole bh) {
        drain();
        bh.consume(new SoftReference<>(new Object(), rq));
        bh.consume(new byte[10000]);
    }

}
